<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item :label="t('mall.type')" prop="type">
        <el-select v-model="formData.type" :placeholder="t('mall.pleaseSelectType')">
          <el-option :label="t('mall.selectType')" value="" />
          <el-option :label="t('mall.page')" value="pages" />
          <el-option :label="t('mall.jumpToMiniProgram')" value="miniprogram" />
          <el-option :label="t('mall.content')" value="content" />
          <el-option :label="t('mall.phone')" value="call" />
        </el-select>
      </el-form-item>
      <el-form-item :label="t('mall.title')" prop="name">
        <el-input v-model="formData.name" :placeholder="t('mall.pleaseEnterTitle')" />
      </el-form-item>
      <el-form-item :label="t('mall.icon')" prop="image">
          <Materials v-model="formData.image" num="1" type="image" />
      </el-form-item>
      <el-form-item :label="t('mall.miniProgramAppId')" prop="appId">
        <el-input v-model="formData.appId" :placeholder="t('mall.pleaseEnterMiniProgramAppId')" />
      </el-form-item>
      <el-form-item :label="t('mall.pagePath')" prop="pages">
        <el-input v-model="formData.pages" :placeholder="t('mall.pleaseEnterPagePath')" />
      </el-form-item>
      <el-form-item :label="t('mall.content')">
        <Editor v-model="formData.content" height="150px" />
      </el-form-item>
      <el-form-item :label="t('mall.phone')" prop="phone">
        <el-input v-model="formData.phone" :placeholder="t('mall.pleaseEnterPhone')" />
      </el-form-item>
      <el-form-item :label="t('mall.weight')" prop="weigh">
        <el-input v-model="formData.weigh" :placeholder="t('mall.pleaseEnterWeight')" />
      </el-form-item>
      <el-form-item :label="t('public.status')" prop="status">
        <el-radio-group v-model="formData.status">
          <el-radio :label="1">{{ t('public.up') }}</el-radio>
          <el-radio :label="0">{{ t('public.down') }}</el-radio>
        </el-radio-group>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">{{t('common.confirm')}}</el-button>
      <el-button @click="dialogVisible = false">{{t('common.cancel')}}</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import * as ServiceApi from '@/api/mall/shop/service'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  name: undefined,
  image: undefined,
  type: undefined,
  content: '',
  pid: undefined,
  appId: undefined,
  pages: undefined,
  phone: undefined,
  weigh: undefined,
  status: 1
})
const formRules = reactive({
  type: [{ required: true, message: t('mall.typeCannotBeEmpty'), trigger: 'blur' }],
  name: [{ required: true, message: t('mall.titleCannotBeEmpty'), trigger: 'blur' }],
  image: [{ required: true, message: t('mall.iconCannotBeEmpty'), trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await ServiceApi.getService(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as ServiceApi.ServiceVO
    if (formType.value === 'create') {
      await ServiceApi.createService(data)
      message.success(t('common.createSuccess'))
    } else {
      await ServiceApi.updateService(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    name: undefined,
    image: undefined,
    type: undefined,
    content: '',
    pid: undefined,
    appId: undefined,
    pages: undefined,
    phone: undefined,
    weigh: undefined,
    status: 1
  }
  formRef.value?.resetFields()
}
</script>
